# samples

In the context of Furnace, a sound sample (usually just referred to as a sample) is a string of numbers that hold sampled PCM audio.

In Furnace, these samples can be generated by importing a .wav (think of it as an higher quality MP3) file.

## supported systems

As of Furnace 0.6, the following sound chips have sample support:
 - NES/Ricoh 2A03 (with DPCM support and only on channel 5)
 - Sega Genesis/YM2612 (channel 6 only; but only if there exists a `1701` effect that gets played on or before a trigger for a sample, or if you are using an instrument with Sample type)
 - PC Engine/TurboGrafx 16/Huc6280 (same conditions as above)
 - Amiga/Paula (on all channels)
 - Arcade/SEGA PCM (same as above)
 - Neo Geo/Neo Geo CD (on the last 7 channels (6 if you are using Neo Geo CD) only and can be resampled the same way as above)
 - Seta/Allumer X1-010 (same as YM2612)
 - Atari Lynx
 - MSM6258 and MSM6295
 - YMU759/MA-2 (last channel only)
 - QSound
 - ZX Spectrum 48k
 - RF5C68
 - WonderSwan
 - Tildearrow Sound Unit
 - VERA (last channel only)
 - Y8590 (last channel only)
 - And a few more that I've forgotten to mention.

Furnace also has a feature where you can make an Amiga formarted instrument on the YM2612 and Huc6280 to resample a sample you have in the module.

# the sample editor

You can actually tweak your samples in Furnace's sample editor, which can be accessed by clicking on `window` (at the top of the screen) then clicking on `sample editor`.

In there, you can modify certain data pertaining to your sample, such as the:
 - volume of the sample in percentage, where 100% is the current level of the sample (note that you can distort it if you put it too high)
 - the sample rate, from 0Hz (no sample movement) to 65535Hz (65.5kHz).
 - what frequencies to filter, along with filter level/sweep and resonance options (much like the C64)
 - and many more.

The changes you make will be applied as soon as you've committed them to your sample, but they can be undoed and redoed, just like text.

# tips
If you have a sample you wanna use that is about 44100 or anything over 32000Hz, downsample the sample to 32000Hz so that the pitch of the sample in Furnace stays like the original audio file. You can do this in Audacity by going to the bottom left of the screen (If you see "Project Rate (Hz)" you are there), change the project rate to 32000Hz and save the file to wav in Audacity using "File -> Export -> Export as WAV".
